####################################################################
### BASIC.PAN - Example of a control panel
###
### The mechanism types and all attributes are defined in gui.def.
### Each mechanism definition begins with a "Proc" line.
### Attributes may be specified in any order.


###########################################
### Window background
### -- optional, but if done, must be done before anything else
###########################################

Proc backing		

### it will be called BACK..
*/tag: BACK		

### background color = light gray
color: 0.9


##########################################
### Buttons 
#########################################

Proc button

### they will be called B1..
*/tag: B1

### center horizonatally in the window..
*/align_h: C root C

### align top of buttons to 0.3 inches below window top..
*/align_v: T root T-0.3

### button text (can also be set using copa text)
text:	New search,View man page,Print man page,Exit

### button should not stay highlighted
flashpick: x


###########################
### Large text box, where individual words can be selected.
###########################

Proc textb

### it will be called TEXT
*/tag: TEXT

### center horizontally in the window..
*/align_h: C root C

### align top of textbox to 0.2 inches below buttons..
*/align_v: T B1 B-0.2

### 40 lines
nlines: 30

### 80 chars wide
box.width: 88

### 10 point text
text/size: 10

### make it selectable..
pick: x

### make it return only the first token on selected line..
result.format: 1

### make it ruled with lines
ruled: L

### put in some demo text
text: 
"NIS+		nis+ (1)	- a new version of the network information name service"
"byteorder	byteorder (3n)	- convert values between host and network byte order"
"dfstab		dfstab (4)	- file containing commands for sharing resources across a network"
"endhostent	gethostbyname (3n)  - get network host entry"
"endnetconfig	getnetconfig (3n)   - get network configuration database entry"
"endnetent	getnetbyname (3n)   - get network entry"
"endnetgrent	getnetgrent (3n)    - get network group entry"
"gethostbyaddr	gethostbyname (3n)  - get network host entry"
"gethostbyaddr_r gethostbyname (3n)  - get network host entry"
"gethostbyname	gethostbyname (3n)  - get network host entry"
"gethostbyname_r gethostbyname (3n)  - get network host entry"
"gethostent	gethostbyname (3n)  - get network host entry"
"gethostent_r	gethostbyname (3n)  - get network host entry"
"getnetbyaddr	getnetbyname (3n)   - get network entry"
"getnetbyaddr_r	getnetbyname (3n)   - get network entry"
"getnetbyname	getnetbyname (3n)   - get network entry"
"getnetbyname_r	getnetbyname (3n)   - get network entry"
"getnetconfig	getnetconfig (3n)   - get network configuration database entry"
"getnetconfigent getnetconfig (3n)   - get network configuration database entry"
"getnetent	getnetbyname (3n)   - get network entry"
"getnetent_r	getnetbyname (3n)   - get network entry"
"getnetgrent	getnetgrent (3n)    - get network group entry"
"getnetgrent_r	getnetgrent (3n)    - get network group entry"
"htonl		byteorder (3n)	- convert values between host and network byte order"
"htons		byteorder (3n)	- convert values between host and network byte order"
"if		if_tcp (7)	- general properties of Internet Protocol network interfaces"
"if_tcp		if_tcp (7)	- general properties of Internet Protocol network interfaces"
"ifconfig	ifconfig (1m)	- configure network interface parameters"
"in.rdisc	in.rdisc (1m)	- network router discovery daemon"
"in.routed	in.routed (1m)	- network routing daemon"
"inet_network	inet (3n)	- Internet address manipulation"
"innetgr		getnetgrent (3n)    - get network group entry"
"listen		listen (1m)	- network listener daemon"
"lockd		lockd (1m)	- network lock daemon"
"nc_perror	getnetconfig (3n)   - get network configuration database entry"
"nc_sperror	getnetconfig (3n)   - get network configuration database entry"
"netconfig	netconfig (4)	- network configuration database"
"netgroup	netgroup (4)	- list of network groups"
"netmasks	netmasks (4)	- network mask database"
"netstat		netstat (1m)	- show network status"
"networks	networks (4)	- network name database"
"nfsstat		nfsstat (1m)	- Network File System statistics"
"nis		nis+ (1)	- a new version of the network information name service"
"nis+		nis+ (1)	- a new version of the network information name service"
"nlsadmin	nlsadmin (1m)	- network listener service administration"
"ntohl		byteorder (3n)	- convert values between host and network byte order"
"ntohs		byteorder (3n)	- convert values between host and network byte order"
"ping		ping (1m)	- send ICMP ECHO_REQUEST packets to network hosts"
"rdisc		in.rdisc (1m)	- network router discovery daemon"
"routed		in.routed (1m)	- network routing daemon"
"routing		routing (4)	- system support for packet network routing"
"rpc.rusersd	rpc.rusersd (1m)    - network username server"
"rpc.rwalld	rpc.rwalld (1m) - network rwall server"
"rpld		rpld (1m)	- x86 Network Booting RPL (Remote Program Load) Server"
"rusersd		rpc.rusersd (1m)    - network username server"
"rwall		rwall (1m)	- write to all users over a network"
"rwalld		rpc.rwalld (1m) - network rwall server"
"sethostent	gethostbyname (3n)  - get network host entry"
"setnetconfig	getnetconfig (3n)   - get network configuration database entry"
"setnetent	getnetbyname (3n)   - get network entry"
"setnetgrent	getnetgrent (3n)    - get network group entry"
"snoop		snoop (1m)	- capture and inspect network packets"
"spray		spray (3n)	- scatter data in order to test the network"
"statd		statd (1m)	- network status monitor"
"tr		tr (7)		- IBM 16/4 Token Ring Network Adapter device driver"
"ttyhstmgr	ttyhstmgr (1m)	- administer hosts on a network"
"ypfiles		ypfiles (4)	- Network Information Service Version 2, formerly knows as YP"
"yppasswd	yppasswd (1)	- change your network password in the NIS database"
