####################################################################
### ONEPLOT.PAN - A single plot
###
### The mechanism types and all attributes are defined in gui.def and plot.def.
### Each mechanism definition begins with a "Proc" line.
### Attributes may be specified in any order.

### Backing
Proc backing
color: 1



### Centered title
Proc textb
*/tag: TITLE
*/align_h: C root C
*/align_v: T root T-0.2
text/size: 15
text:	Copa plot template

### Data to be plotted is housed in a textb (not visible)
Proc textb
*/tag: DATALIST
### don't display this textbox..
*/display:
text:
00 0 0 0 1 0.00 0.00 8611       0      0      0      0      0 
00 1 2 0 0 0.00 0.00 8612       1      0      1      1      3 
00 2 2 2 1 1.33 0.67 8701       0      1      0      2      3 
00 3 3 3 7 6.67 4.33 8702       1      2      2      2      7 
00 4 8 2 5 10.00 5.00 8703       0      2      0      3      5 
00 5 4 4 7 10.67 6.33 8704       1      2      4      6     13 
00 6 14 11 4 10.67 5.33 8705       1      6      1      3     11 
00 7 15 6 9 13.00 10.00 8706       4      3      6     11     24 
00 8 14 5 10 14.67 9.33 8707       4      8      7      7     26 
00 9 8 8 15 16.67 7.83 8708       4      4      5      6     19 
00 10 9 9 13 16.33 8.17 8709       2      2      5     13     22 
00 11 11 10 6 18.67 10.33 8710       1      2      5     18     26 
00 12 7 9 11 16.67 8.33 8711       2      6      3      5     16 
00 13 6 10 12 16.67 8.33 8712       2      5      3     14     24 
00 14 8 11 14 16.83 8.42 8801       2      4      1     10     17 
00 15 10 5 8 16.83 8.42 8802       0      6      2     13     21 
00 16 12 9 16 17.17 8.58 8803       0      5      8     16     29 
00 17 8 12 20 17.17 8.58 8804       1      5      7     12     25 
00 18 8 11 7 17.17 8.58 8805       3      1      5     16     25 
00 19 7 12 8 17.17 8.58 8806       6     11     13     12     42 
00 20 4 6 6 17.17 8.58 8807       2      5      6     11     24 
00 21 8 12 12 17.17 8.58 8808       3      4      4     14     25 
00 22 1 14 12 17.33 8.67 8809       0      4     10     14     28 
00 23 2 5 10 17.33 8.67 8810       2      4      5     12     23 
00 24 1 7 8 17.33 8.67 8811       2      3      5     11     21 
00 25 4 5 5 17.33 8.67 8812       4      7      4      9     24 

### set up scaling and position..
Proc scalezone
*/tag: PLOTZONE1
*/align_h: C root C
*/align_v: B root B+2
height: 4
width: 6
xrange: 0 30
yrange: 0 25


### create axes, including month/year labels on x, beginning with 11/90
Proc Axes
*/tag: AXES2
Plot/Zone: PLOTZONE1
Yinc: 10
Subtitle: Performance over time
Xstart.0or1: 1
Xstub: month
Xstub.startmonth:	11
Xstub.startyear:	90
Subtitle.justify:	left
Subtitle.above:		0.02
Yinc:			5
Xstart.0or1:		1
Ystub.grid: line

### do the bar graph..
Proc Bargraph:
Plot/Zone: PLOTZONE1
Plot/Datasource: DATALIST
Field:			5
Shade:			0
Idfield:		5

### superimpose a line plot..
Proc Lineplot:
Plot/Zone: PLOTZONE1
Yfield:			7 6
Linetype:		1 2
Linetype.magnify:	2 2
Stairstep.bars:		y
Xstart.0or1:		1

### do a legend.. first set up a scalezone (alignment info only)
Proc scalezone:
*/tag: LEGEND
*/align_h: C root C
*/align_v: B root B
height: 0.7
width: 1.5
#don't fill box
color: -1

### do the legend..
Proc Legend
Plot/Zone: LEGEND
Title: Legend
Entry:  Goal - east
	Goal - west
Linetype: 0 1

