######################################################
### SLIDER.PAN - control panel with 3 sliders and a button
###
### The mechanism types and all attributes are defined in gui.def.
### Each mechanism definition begins with a "Proc" line.
### Attributes may be specified in any order.
####################################################################


###########################################
### Window background
######################################################

######################
### backing box
###  In this case, we're using a text box as backing..
######################

Proc textb

### it will be called BACK..
*/tag:		BACK

### it will be centered in the window..
*/align_h: 	"C root C" 
*/align_v: 	"C root C" 

### 50 characters wide..
box.width:	50

### 12 point text..
text/size:	12

### display 30 lines.. 
nlines:		30

### decorate the rectangle (shadow)..
dress:		x

### make a big shadow..
dress/shadow.size: 0.4

### center lines of text..
align:		C

### display this text..
text:		This is an example control panel with three 
		slider mechanisms.  As opposed to popup boxes, 
		which can only get a single response, a control 
		panel can have many response mechanisms which
		operate independently.

		This panel is defined in the file 'slider.pan', 
		and loaded using the copa loadpan command.

		The sliders can be adjusted by clicking with
		the mouse.  Click on 'OK' when finished..


########################
### Slider 1
########################

Proc slider

### it will be called HEIGHT..
*/tag:		HEIGHT

### center it horizontally within the backing..
*/align_h: 	"C BACK C" 

### align with the top 2.5 inches down from the top of the backing..
*/align_v: 	"T BACK T-2.5" 

### use this text as the prompt..
prompt: 	Height (in):

### the minimum value..
min:		20

### the maximum value..
max:		80

### the starting default value..
pick/value:	60


########################
### Slider 2
########################
Proc slider
*/tag: 		WEIGHT
*/align_h: 	"C BACK C" 
*/align_v: 	"T BACK T-3" 
prompt: 	Weight (lbs):
min:		20
max:		300
pick/value:	160


########################
### Slider 3
########################
Proc slider
*/tag: 		IQ
*/align_h: 	"C BACK C" 
*/align_v: 	"T BACK T-3.5" 
prompt: 	IQ:
min:		20
max:		150
pick/value:	100


########################
### The button
########################
Proc button

### it will be called B1..
*/tag:		B1

### center it horizontally within the backing..
*/align_h: 	"C BACK C" 

### align so its bottom is 0.5 inches above the bottom of the backing..
*/align_v: 	"B BACK B+0.5"

### the text to be displayed in the button
text:		OK

### we don't want it to stay highlighted..
flashpick: x
